stages: [validate, generate, publish]

lint:
  stage: validate
  tags: [docker]
  image: asciidoctor/docker-asciidoctor:latest
  script: |
    find ./ -type f -name "*.adoc" | while read file
    do
      echo linting $file
      asciidoctor $file --failure-level=FATAL --trace --verbose -t -o - > /dev/null
    done

antora_preview:
  stage: generate
  tags: [docker]
  image: antora/antora:latest
  only:
    - merge_requests
  cache:
    paths:
      - .cache
  script: |
    sed -i s/current_branch/$CI_COMMIT_REF_NAME/ antora-playbook.yml
    yarn global add @antora/lunr-extension
    yarn global add @antora/pdf-extension
    yarn global add asciidoctor-pdf
    antora antora-playbook.yml
  environment:
    name: merge_review/$CI_COMMIT_REF_SLUG
    url: "https://gadhs.gitlab.io/ofi/-/$CI_PROJECT_NAME/-/jobs/$CI_JOB_ID/artifacts/public/rpa-ai-strategy/index.html"
  artifacts:
    paths:
    - public
    - build

pages:
  stage: publish
  tags: [docker]
  image: antora/antora:latest
  rules:
    - if: $CI_COMMIT_BRANCH == 'main'
  cache:
    paths:
      - .cache
  script: |
    sed -i s/current_branch/$CI_COMMIT_REF_NAME/ antora-playbook.yml
    apk update
    apk add ruby
    gem install asciidoctor-pdf
    yarn global add @antora/lunr-extension
    yarn global add @antora/pdf-extension
    antora --stacktrace antora-playbook.yml
  artifacts:
    paths:
    - public
    - build